///home/berryj/link/bin/genMethods "-g" "-t" "Vertex*" "-h" "List" "-I" "LINK/basic/List.h" "-I" "LINK/graph/Vertex.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/List.h>

#include <LINK/graph/Vertex.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/ListWrapper.h>


typedef Vertex* _Vertex_;
typedef List<Vertex* > _List_Vertex__;
static List<Vertex* > s__List_Vertex__;

#define _List_Vertex__DATA(x) ((List<Vertex* >*) (EXTDATA(x)))
#define _List_Vertex__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<Vertex* > >::type))
#define _List_Vertex__ISNT_DATA(x) (!_List_Vertex__IS_DATA(x))

#define _List_Vertex__CXX_DATA(x) (*(List<Vertex* >*) (EXTDATA(VAL(x))))
#define _List_Vertex__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<Vertex* > >::type))
#define _List_Vertex__CXX_ISNT_DATA(x) (!_List_Vertex__CXX_IS_DATA(x))


PRIMITIVE STk_init__List_Vertex__()
{
	Wrapper<_List_Vertex__>::type = STk_new_CXXwrapper_id(
			Wrapper<_List_Vertex__>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			ListWrapper<_Vertex_>::displayTypedList,
			(void (*)(SCM x))ListWrapper<_Vertex_>::markTypedList,
			(void (*)(SCM x))ListWrapper<_Vertex_>::freeTypedList);
	Tcl_InitHashTable(&Register<_List_Vertex__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_List_Vertex__Methods(void);

PRIMITIVE STk_init_methods__List_Vertex__()
{
	STk_add_new_cpp_primitive("List-Vertex-make", tc_subr_0, 
	(PRIMITIVE (*)(...))  ListWrapper<_Vertex_>::makeLinkList);
	STk_add_new_cpp_primitive("List-Vertex?", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Vertex_>::linkListP);
	STk_add_new_cpp_primitive("list->List-Vertex", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Vertex_>::stkList2LinkList);
	STk_add_new_cpp_primitive("List-Vertex->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Vertex_>::linkList2STkList);
	genExtra_List_Vertex__Methods();
	return UNDEFINED;
}
